function capitalizeFirstLetter(string) {
    return string.charAt(0).toUpperCase() + string.slice(1);
  }
  
  var table = newTabulator('#example-table', {
    layout: 'fitData',
    placeholder: 'Loading',
    selectable: 1,
  });
  
  document.getElementById('download-csv').addEventListener('click', function () {
    table.download('csv', 'results.csv');
    const rowCount = table.getRows().length;
    console.log('Downloaded ' + rowCount + ' emails.');

    // rolecheck()
    //   .then(function (userData) {
    //     const quota = userData.quota || 0;
    //     var usedQuota = userData.used || 0;
    //     if (usedQuota < quota) {
    //       table.download('csv', 'results.csv');
    //       const rowCount = table.getRows().length;
    //       console.log('Downloaded ' + rowCount + ' emails.');
    //       updateuse(rowCount);
    //       usedQuota += rowCount;
    //       document.getElementById('accountinfo').innerHTML =
    //         'Current Plan: ' +
    //         userData.plan +
    //         ', Quota: ' +
    //         quota +
    //         ', Used: ' +
    //         usedQuota;
    //     } else {
    //       alert('Download Quota Used UP, Please Upgrade your plan.');
    //       upgradeToPro();
    //     }
    //   })
    //   .catch((error) => {
    //     console.log(error);
    //   });
  });
  
  document.getElementById('download-xlsx').addEventListener('click', function () {
    table.download('xlsx', 'results.xlsx', { sheetName: 'My Data' });
    const rowCount = table.getRows().length;
    console.log('Downloaded ' + rowCount + ' emails.');
    
    // rolecheck()
    //   .then(function (userData) {
    //     const quota = userData.quota || 0;
    //     var usedQuota = userData.used || 0;
    //     if (usedQuota < quota) {
    //       table.download('xlsx', 'results.xlsx', { sheetName: 'My Data' });
    //       const rowCount = table.getRows().length;
    //       console.log('Downloaded ' + rowCount + ' emails.');
    //       updateuse(rowCount);
    //       usedQuota += rowCount;
    //       document.getElementById('accountinfo').innerHTML =
    //         'Current Plan: ' +
    //         userData.plan +
    //         ', Quota: ' +
    //         quota +
    //         ', Used: ' +
    //         usedQuota;
    //     } else {
    //       alert('Download Quota Used UP, Please Upgrade your plan.');
    //       upgradeToPro();
    //     }
    //   })
    //   .catch((error) => {
    //     console.log(error);
    //   });
  });
  
  function flattenObject(obj, prefix = '') {
    const flattened = {};
    for (const [key, value] of Object.entries(obj)) {
      const prefixedKey = prefix ? prefix + '_' + key : key;
      typeof value === 'object' && value !== null
        ? Object.assign(flattened, flattenObject(value, prefixedKey))
        : (flattened[prefixedKey] = value);
    }
    return flattened;
  }
  
  function generateColumns(keys) {
    const defaultKeys = new Set([
      'name',
      'phone',
      'email',
      'website',
      'address',
      'instagram',
      'facebook',
      'twitter',
      'linkedin',
      'yelp',
      'youtube',
      'placeID',
      'cID',
      'category',
      'reviewCount',
      'averageRating',
      'latitude',
      'longitude',
    ]);
    var columns = [];
    defaultKeys.forEach((key) => {
      columns.push({
        title: capitalizeFirstLetter(key),
        field: key,
        width: 300,
        resizable: true,
      });
    });
    const sortedKeys = Array.from(keys).sort();
    sortedKeys.forEach((key) => {
      !defaultKeys.has(key) &&
        columns.push({
          title: capitalizeFirstLetter(key),
          field: key,
          width: 300,
          resizable: true,
        });
    });
    table.setColumns(columns);
  }
  
  function showData() {
    chrome.storage.local.get(null, function (leadsData) {
      const leads = leadsData.leads || [];
      var keysSet = new Set(),
        flattenedLeads = [];
      for (var i = 0; i < leads.length; ++i) {
        const flattenedLead = flattenObject(leads[i]);
        flattenedLeads.push(flattenedLead);
        Object.keys(flattenedLead).forEach((key) => keysSet.add(key));
      }
      generateColumns(keysSet);
      table.setData(flattenedLeads);
    });
  }
  
  function normalizeProfileId(profileId) {
    return profileId.replace('@', '').trim().toLowerCase();
  }
  
  $(document).ready(function () {
    showData();
    // chrome.storage.sync.get(null, function (userData) {
    //   var displayName = userData.displayName,
    //     uid = userData.uid;
    //   uid &&
    //     rolecheck().then(function (userInfo) {
    //       document.getElementById('accountinfo').innerHTML =
    //         'Current Plan: ' +
    //         userInfo.plan +
    //         ', Quota: ' +
    //         userInfo.quota +
    //         ', Used: ' +
    //         userInfo.used;
    //     });
    // });
  });
  